/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package poll;

import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.Font;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.ArrayList;
import java.util.StringTokenizer;
import javax.swing.Box;
import javax.swing.ButtonGroup;
import javax.swing.JButton;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JRadioButton;
import javax.swing.filechooser.FileNameExtensionFilter;

import domande.OpenSave;
import domande.dati.Domanda;
import domande.dati.PollDb;

/**
 *
 * @author Giuseppe
 */
public class Grafix
{
	private JLabel domText;
	private JLabel numDom;
	private JRadioButton jRisp1;
	private JRadioButton jRisp2;
	private JRadioButton jRisp3;
	private JRadioButton jRisp4;
	private ButtonGroup jbg;
	private JFrame jfrm;
	private JButton jAvanti;
	private ArrayList<Domanda> doms;
	private int count;
	private int totDom;
	private String fileName;
	private String tTitle;
	private String appName;

	public Grafix()
	{
		if (!initDB()) {
			JOptionPane.showMessageDialog(null, "Impossibile inizializzare il DB, applicazione verr chiusa!", this.appName, JOptionPane.ERROR_MESSAGE);
			return;
		}
		this.appName = new String("PollAnswer");

		this.jfrm = new JFrame(this.appName+": "+this.tTitle);
		this.jfrm.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		this.jfrm.setExtendedState(this.jfrm.getExtendedState() | JFrame.MAXIMIZED_BOTH);
		this.jfrm.setSize(800, 600);

		inizia();

		this.jfrm.setVisible(true);
	}

	private boolean initDB() {
		JFileChooser file = new JFileChooser();
		FileNameExtensionFilter filtro = new FileNameExtensionFilter("Poll xml file: *.xml", new String[] { "xml" });
		file.setFileFilter(filtro);
		int retVal = file.showOpenDialog(this.jfrm);
		if (retVal != 0) {
			JOptionPane.showMessageDialog(jfrm, "Impossibile caricare il file", this.appName, JOptionPane.ERROR_MESSAGE);
			return false;
		}

		this.fileName = new String(file.getSelectedFile().getPath());

		PollDb poll = OpenSave.apri(this.fileName);
		if(poll == null) 
			return false;

		this.doms = poll.getDomande();
		this.tTitle = poll.getTitle();
		this.totDom = this.doms.size();
		this.count = 0;

		return true;
	}

	private void inizia()
	{
		this.jfrm.getContentPane().removeAll();
		this.jfrm.setLayout(new GridLayout(2, 1));
		JPanel p1 = new JPanel(new FlowLayout());
		JLabel title = new JLabel(generateHtmlString(this.tTitle, 30));
		Font f = new Font("Arial Bold", 0, 100);
		title.setFont(f);
		p1.add(title);

		JPanel p2 = new JPanel(new FlowLayout());
		JButton inizia = new JButton("Inizia!");
		inizia.addActionListener(new ActionListener()
		{
			public void actionPerformed(ActionEvent e) {
				Grafix.this.faiDomande();
			}
		});
		inizia.setFont(f);
		p2.add(inizia);

		this.jfrm.add(p1);
		this.jfrm.add(p2);

		this.jfrm.validate();
		this.jfrm.repaint();
	}

	private void faiDomande()
	{
		drawDomande();
		initDomanda();
	}

	private void drawDomande() {
		this.jfrm.getContentPane().removeAll();
		this.jfrm.setLayout(new GridLayout(6, 1));

		JPanel pan1 = new JPanel(new FlowLayout());
		this.domText = new JLabel("");
		this.domText.setFont(new Font("Arial Bold", 0, 50));
		pan1.add(this.domText);
		this.jfrm.add(pan1);

		JPanel pan2 = new JPanel(new FlowLayout());
		this.jRisp1 = new JRadioButton("");
		this.jRisp1.setFont(new Font("Arial Bold", 0, 30));
		pan2.add(this.jRisp1);
		this.jfrm.add(pan2);

		JPanel pan3 = new JPanel(new FlowLayout());
		this.jRisp2 = new JRadioButton("");
		this.jRisp2.setFont(new Font("Arial Bold", 0, 30));
		pan3.add(this.jRisp2);
		this.jfrm.add(pan3);

		JPanel pan4 = new JPanel(new FlowLayout());
		this.jRisp3 = new JRadioButton("");
		this.jRisp3.setFont(new Font("Arial Bold", 0, 30));
		pan4.add(this.jRisp3);
		this.jfrm.add(pan4);

		JPanel pan5 = new JPanel(new FlowLayout());
		this.jRisp4 = new JRadioButton("");
		this.jRisp4.setFont(new Font("Arial Bold", 0, 30));
		pan5.add(this.jRisp4);
		this.jfrm.add(pan5);

		this.jbg = new ButtonGroup();
		this.jbg.add(this.jRisp1);
		this.jbg.add(this.jRisp2);
		this.jbg.add(this.jRisp3);
		this.jbg.add(this.jRisp4);

		JPanel pan6 = new JPanel(new GridLayout(1, 2));
		JPanel panel2 = new JPanel(new FlowLayout());
		this.numDom = new JLabel("Domanda: 0 di " + this.totDom);
		this.numDom.setFont(new Font("Arial Bold", 0, 26));
		panel2.add(this.numDom);
		pan6.add(panel2);

		JPanel panel1 = new JPanel(new FlowLayout());
		this.jAvanti = new JButton("Avanti");
		this.jAvanti.setFont(new Font("Arial Bold", 0, 26));
		this.jAvanti.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				Grafix.this.avanti();
			}
		});
		panel1.add(this.jAvanti);
		pan6.add(panel1);

		this.jfrm.add(pan6);
		this.jfrm.validate();
		this.jfrm.repaint();
	}

	private void initDomanda() {
		Domanda d = (Domanda)this.doms.get(this.count);

		this.domText.setText(generateHtmlString(d.getDomanda(), 40));
		this.jRisp1.setText(d.getRisp1());
		this.jRisp1.setSelected(true);
		this.jRisp2.setText(d.getRisp2());

		if (d.isAttRisp3()) {
			this.jRisp3.setVisible(true);
			this.jRisp3.setText(d.getRisp3());
		} else {
			this.jRisp3.setVisible(false);
		}

		if (d.isAttRisp4()) {
			this.jRisp4.setVisible(true);
			this.jRisp4.setText(d.getRisp4());
		} else {
			this.jRisp4.setVisible(false);
		}

		this.numDom.setText("Domanda: " + (this.count + 1) + " di " + this.totDom);
	}

	private void avanti()
	{
		if (this.jRisp1.isSelected())
			((Domanda)this.doms.get(this.count)).incRisp1();
		else if (this.jRisp2.isSelected())
			((Domanda)this.doms.get(this.count)).incRisp2();
		else if (this.jRisp3.isSelected())
			((Domanda)this.doms.get(this.count)).incRisp3();
		else {
			((Domanda)this.doms.get(this.count)).incRisp4();
		}
		if (this.count == this.totDom - 1) {
			this.count = 0;
			if (saveDB())
			{
				fine();
			}
			else JOptionPane.showMessageDialog(jfrm, "Errore nel salvatare i dati, riaprire il programma.", this.appName, JOptionPane.ERROR_MESSAGE);
		}
		else if (this.count == this.totDom - 2) {
			this.jAvanti.setText("Fine!");
			this.count += 1;
			initDomanda();
		}
		else {
			this.count += 1;
			initDomanda();
		}
	}

	private boolean saveDB()
	{
		PollDb poll = new PollDb(this.doms, this.tTitle);

		if(OpenSave.salva(poll, this.fileName) == false) {
			JOptionPane.showMessageDialog(jfrm, "Modifiche non salvate", this.appName, JOptionPane.WARNING_MESSAGE);
			return false;
		}
		return true;
	}

	private void fine() {
		this.jfrm.getContentPane().removeAll();
		this.jfrm.setLayout(new GridLayout(3, 1));

		JPanel p1 = new JPanel(new FlowLayout());
		JLabel title = new JLabel(generateHtmlString(this.tTitle, 30));
		Font f = new Font("Arial Bold", 0, 100);
		title.setFont(f);
		p1.add(title);
		p1.add(Box.createRigidArea(new Dimension(0, 50)));

		JPanel p2 = new JPanel(new FlowLayout());
		JLabel text = new JLabel("Grazie di aver partecipato!");
		f = new Font("Arial Bold", 0, 80);
		text.setFont(f);
		p2.add(text);

		JPanel p3 = new JPanel(new FlowLayout());
		JButton bContinua = new JButton("Continua...");
		bContinua.addActionListener(new ActionListener()
		{
			public void actionPerformed(ActionEvent e) {
				Grafix.this.inizia();
			}
		});
		bContinua.setFont(f);
		p3.add(bContinua);

		this.jfrm.add(p1);
		this.jfrm.add(p2);
		this.jfrm.add(p3);

		this.jfrm.validate();
		this.jfrm.repaint();
	}

	private String generateHtmlString(String s, int lenMaxRiga)
	{
		String out = new String("");
		String v;

		if(s.length() <= lenMaxRiga) {
			return s;
		} else {
			int count = 0;
			StringTokenizer st = new StringTokenizer(s);
			while(st.hasMoreTokens()) {
				v = st.nextToken();
				if((v.length() + count) >= lenMaxRiga) {
					out += " " + v + "<br/>" ;
					count = 0;
				} else {
					out += " " + v;
					count += v.length();
				}
			}
			out = "<html><center>" + out + "</center></html>";
			return out;
		}

	}
}
