package domande;

import java.io.File;
import java.util.ArrayList;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.NodeList;
import domande.dati.Domanda;
import domande.dati.PollDb;

public class XMLReader {
	private Document doc;
	
	public XMLReader(String fileName) throws Throwable { //faccio gestire le eccezioni dal chiamante
		
		DocumentBuilderFactory docBuilderFactory = DocumentBuilderFactory.newInstance();
        DocumentBuilder docBuilder = docBuilderFactory.newDocumentBuilder();
        doc = docBuilder.parse (new File(fileName));

        // normalizzo la rappresentazione del testo
        doc.getDocumentElement ().normalize ();		
	}
	
	public PollDb prendiDati() throws BadPollXMLFileException { //faccio gestire le ecc. dal chiamante

		Element nodo = null;
		
		Element sondaggio = doc.getDocumentElement();
		if( sondaggio.getNodeName().compareTo("sondaggio") != 0)
			throw new BadPollXMLFileException("Non  presente il tag sondaggio");
	
		//prendo il tag titoloPoll
		nodo =  (Element) sondaggio.getChildNodes().item(1);
		if(nodo == null || nodo.getNodeName().compareTo("titoloPoll") != 0) {
			throw new BadPollXMLFileException("Non  presente il tag titolo sondaggio");
		}
		
		String titolo = nodo.getFirstChild().getNodeValue();
		return new PollDb(this.leggiTagsDomanda(), titolo);
		
	}
	
	private ArrayList<Domanda> leggiTagsDomanda() throws BadPollXMLFileException { //faccio gestire le ecc. dal chiamante
		try {

			Element nodo = null;
			Domanda d = null;
			ArrayList<Domanda> aDomande = null;

			//per far prima prendo tutti i nodi domanda cos
			NodeList domande = doc.getElementsByTagName("domanda");
			if(domande.getLength() == 0)
				throw new BadPollXMLFileException("Non sono presenti i tag domanda");

			aDomande = new ArrayList<Domanda>();
			for(int i = 0; i < domande.getLength(); i++, aDomande.add(d)) {
				NodeList eDomanda = domande.item(i).getChildNodes();

				// controllo la sequenza esatta dei tag

				//prendo il titolo
				nodo = (Element) eDomanda.item(1);
				if(nodo == null || nodo.getNodeName().compareTo("titoloDomanda") != 0) 
					throw new BadPollXMLFileException("Non  presente il tag titoloDomanda");
				d = new Domanda(); //la creo solo se  necessio
				d.setDomanda(nodo.getFirstChild().getNodeValue());


				//prendo la prima risposta
				nodo = (Element) eDomanda.item(3);
				if(nodo == null || nodo.getNodeName().compareTo("risposta") != 0) 
					throw new BadPollXMLFileException("Non  presente il tag risposta");
				d.setRisp1(nodo.getFirstChild().getNodeValue());
				if(nodo.hasAttribute("num") == false)
					throw new BadPollXMLFileException("Non  presente l'attributo numero");
				d.setNumRisp1(Integer.parseInt(nodo.getAttribute("num")));

				//prendo la seconda risposta
				nodo = (Element) eDomanda.item(5);
				if(nodo == null || nodo.getNodeName().compareTo("risposta") != 0) 
					throw new BadPollXMLFileException("Non  presente il tag risposta");
				d.setRisp2(nodo.getFirstChild().getNodeValue());
				if(nodo.hasAttribute("num") == false)
					throw new BadPollXMLFileException("Non  presente l'attributo numero");
				d.setNumRisp2(Integer.parseInt(nodo.getAttribute("num")));

				//prendo la terza risposta
				nodo = (Element) eDomanda.item(7);
				if(nodo == null) 
					continue; //non c' la terza risposta
				if(nodo.getNodeName().compareTo("risposta") != 0) 
					throw new BadPollXMLFileException("Non  presente il tag risposta");
				d.setRisp3(nodo.getFirstChild().getNodeValue());
				if(nodo.hasAttribute("num") == false)
					throw new BadPollXMLFileException("Non  presente l'attributo numero");
				d.setNumRisp3(Integer.parseInt(nodo.getAttribute("num")));

				//prendo la terza risposta
				nodo = (Element) eDomanda.item(9);
				if(nodo == null) 
					continue; //non c' la quarta risposta
				if(nodo.getNodeName().compareTo("risposta") != 0) 
					throw new BadPollXMLFileException("Non  presente il tag risposta");
				d.setRisp4(nodo.getFirstChild().getNodeValue());
				if(nodo.hasAttribute("num") == false)
					throw new BadPollXMLFileException("Non  presente l'attributo numero");
				d.setNumRisp4(Integer.parseInt(nodo.getAttribute("num")));
			}

			return aDomande;
		} catch(NumberFormatException ex) {
			throw new BadPollXMLFileException("Il valore dell'attributo non  un intero"); //dico che  un errore nel xml

		}
	}

}
