package pollwriter;

import domande.OpenSave;
import domande.dati.Domanda;
import domande.dati.PollDb;

import java.awt.BorderLayout;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintWriter;
import java.util.ArrayList;
import javax.swing.JButton;
import javax.swing.JEditorPane;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.filechooser.FileNameExtensionFilter;

/**
 *
 * @author Giuseppe
 */
public class Analyzer 
{
	private String appName;
	private JFrame jfrm;
	private JEditorPane epRisultiati;
	private JButton bAzzera;
	private JButton bSalvaHtml;
	private ArrayList<Domanda> doms;
	private String fileName;
	private String tTitle;
	private String tRisultati;

	public Analyzer()
	{
		if (!initDB()) {
			JOptionPane.showMessageDialog(null, "Impossibile inizializzare il DB, applicazione verr chiusa!");
			return;
		}

		this.appName = new String("PollAnalyzer");
		this.jfrm = new JFrame(this.appName + ": " + this.tTitle);
		this.jfrm.setSize(500, 440);
		this.jfrm.setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
		this.jfrm.setLayout(new BorderLayout());

		/*
		 * Pulsanti in alto
		 */
		JPanel pTop = new JPanel(new GridLayout(1, 2));
		bAzzera = new JButton("Azzera risposte");
		bAzzera.addActionListener(new ActionListener() {

			public void actionPerformed(ActionEvent e) {
				azzeraRisposte();
				if(!saveDB()) {
					JOptionPane.showMessageDialog(jfrm, "Errore nel salvare il file sul disco", appName, JOptionPane.ERROR_MESSAGE);
				}
			}
		});
		pTop.add(bAzzera);

		bSalvaHtml = new JButton("Salva su file");
		bSalvaHtml.addActionListener(new ActionListener() {

			public void actionPerformed(ActionEvent e) {
				saveReportFile();
			}
		});
		pTop.add(bSalvaHtml);

		this.jfrm.add(pTop, BorderLayout.NORTH);

		/*
		 * Mostro i risultati
		 */
		epRisultiati = new JEditorPane();
		epRisultiati.setEditable(false);
		epRisultiati.setContentType("text/html");
		epRisultiati.setToolTipText("CTRL + C per copiare il testo selezionato");
		getResult();
		JScrollPane jsp = new JScrollPane(epRisultiati, 20, 30);
		jsp.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
		this.jfrm.add(jsp, BorderLayout.CENTER);

		this.jfrm.setVisible(true);
	}

	private void getResult()
	{
		tRisultati = new String("");
		tRisultati += "<html>\n<head>\n<title>Risultati: "+ tTitle +"</title>\n";
		tRisultati += "<meta name='generator' content='PollAnalyzer' />\n</head>\n";
		tRisultati += "<body>\n<p>\n<center><font size=+2><i>Risultati</i></font><br/><font size=+4>" + tTitle + "</font></center>\n<hr/>\n<br/><br/>\n";
		Domanda a = this.doms.get(0);

		//vedo se il db è vuoto
		int sum = a.getNumRisp1()+a.getNumRisp2()+a.getNumRisp3()+a.getNumRisp4();
		if(sum == 0) {
			bAzzera.setEnabled(false);
		}

		// per ogni domanda
		for (Domanda d : this.doms)
		{
			// faccio i calcoli
			float risp1 = d.getNumRisp1();
			float risp2 = d.getNumRisp2();
			float risp3 = d.getNumRisp3();
			float risp4 = d.getNumRisp4();
			float totRisp = risp1 + risp2 + risp3 + risp4;
			float perRisp1;
			if (risp1 != 0.0F)
				perRisp1 = risp1 / totRisp * 100.0F;
			else
				perRisp1 = 0.0F;
			float perRisp2;
			if (risp2 != 0.0F)
				perRisp2 = risp2 / totRisp * 100.0F;
			else
				perRisp2 = 0.0F;
			float perRisp3;
			if (risp3 != 0.0F)
				perRisp3 = risp3 / totRisp * 100.0F;
			else
				perRisp3 = 0.0F;
			float perRisp4;
			if (risp4 != 0.0F)
				perRisp4 = risp4 / totRisp * 100.0F;
			else {
				perRisp4 = 0.0F;
			}

			// output dei risultati
			tRisultati += "<font size=+2>" + d.getDomanda() + "</font> - <i>Risposte totali: " + (int)totRisp + "</i><br/>\n";
			tRisultati += "<font size=+1>" + d.getRisp1() + "</font> - <i>Risposte: " + d.getNumRisp1() + " (" + perRisp1 + "%)</i><br/>\n";
			tRisultati += "<font size=+1>" + d.getRisp2() + "</font> - <i>Risposte: " + d.getNumRisp2() + " (" + perRisp2 + "%)</i><br/>\n";
			if (d.isAttRisp3()) {
				tRisultati += "<font size=+1>" + d.getRisp3() + "</font> - <i>Risposte: " + d.getNumRisp3() + " (" + perRisp3 + "%)</i><br/>\n";
			}
			if (d.isAttRisp4()) {
				tRisultati += "<font size=+1>" +  d.getRisp4() + "</font> - <i>Risposte: " + d.getNumRisp4() + " (" + perRisp4 + "%)</i><br/>\n";
			}
			tRisultati += "<br/><br/>\n";
		}
		tRisultati += "</p>\n</body>\n</html>";

		// mostro i risultati nel JEditorPane
		epRisultiati.setText(tRisultati);
	}

	private boolean initDB()
	{

		JFileChooser file = new JFileChooser();
		FileNameExtensionFilter filtro = new FileNameExtensionFilter("Poll xml file: *.xml", new String[] { "xml" });
		file.setFileFilter(filtro);
		int retVal = file.showOpenDialog(this.jfrm);
		if (retVal != 0) {
			JOptionPane.showMessageDialog(this.jfrm, "Impossibile caricare il file", this.appName, JOptionPane.ERROR_MESSAGE);
			return false;
		}

		this.fileName = new String(file.getSelectedFile().getPath());
		PollDb poll = OpenSave.apri(this.fileName);

		this.tTitle = poll.getTitle();
		this.doms = poll.getDomande();
		//this.totDom = this.doms.size();

		return true;
	}

	private void azzeraRisposte()
	{
		for (Domanda d : this.doms)
			d.azzera();

		this.bAzzera.setEnabled(false);
		this.getResult();

		this.jfrm.validate();
		this.jfrm.repaint();
	}

	private boolean saveDB()
	{
		try {
			Runtime.getRuntime().gc();
			File f = new File(this.fileName);
			f.delete();

			PollDb poll = new PollDb(this.doms, this.tTitle);
			if(OpenSave.salva(poll, this.fileName))
				JOptionPane.showMessageDialog(this.jfrm, "File salvato in: " + this.fileName, this.appName, JOptionPane.INFORMATION_MESSAGE);
			else
				JOptionPane.showMessageDialog(this.jfrm, "File non salvato in: " + this.fileName, this.appName, JOptionPane.WARNING_MESSAGE);

			Runtime.getRuntime().gc();

			return  true;
		} catch (Exception e) {
			JOptionPane.showMessageDialog(null, e.toString());
		}

		return false;
	}

	private void saveReportFile() 
	{
		try {
			JFileChooser file = new JFileChooser();
			FileNameExtensionFilter filtro = new FileNameExtensionFilter("Html file: *.html", new String[] { "html" });
			file.setFileFilter(filtro);
			int retVal = file.showSaveDialog(this.jfrm);
			if (retVal != 0) {
				JOptionPane.showMessageDialog(this.jfrm, "Impossibile salvare il file", this.appName, JOptionPane.ERROR_MESSAGE);
				return;
			}
			this.fileName = file.getSelectedFile().getPath();

			File f = new File(this.fileName);
			f.delete();

			PrintWriter w = new PrintWriter(f);
			w.print(tRisultati);
			w.close();

			JOptionPane.showMessageDialog(this.jfrm, "File salvato in: " + this.fileName, this.appName, JOptionPane.INFORMATION_MESSAGE);
			return;
		} catch (FileNotFoundException e) {
			JOptionPane.showMessageDialog(this.jfrm, e.toString(), this.appName, JOptionPane.ERROR_MESSAGE);

		}
		return;
	}

}
