package pollwriter;

import domande.OpenSave;
import domande.dati.Domanda;
import domande.dati.PollDb;

import java.awt.BorderLayout;
import java.awt.Container;
import java.awt.Desktop;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.GridLayout;
import java.awt.Toolkit;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowEvent;
import java.awt.event.WindowListener;
import java.io.IOException;
import java.net.URI;
import java.net.URISyntaxException;
import java.util.ArrayList;

import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextField;
import javax.swing.ListSelectionModel;
import javax.swing.event.ListSelectionEvent;
import javax.swing.filechooser.FileNameExtensionFilter;
import javax.swing.*;
import javax.swing.event.ListSelectionListener;

/**
 * 
 * @author Giuseppe
 */
public class Grafix
{
	private String appName;
	private JList<Object> jlist;
	private JFrame jfrm;
	private JTextField testoDom;
	private JTextField testoRisp1;
	private JTextField testoRisp2;
	private JTextField testoRisp3;
	private JTextField testoRisp4;
	private JTextField textTitle;
	private JMenuItem salvaCome;
	private JPanel domandePan;
	private JPanel rightPanel;
	private ArrayList<Domanda> doms;
	private ArrayList<String> textD;
	private int count;
	private int index;
	private String fileName;

	public Grafix()
	{
		this.appName = new String("PollWriter");
		int h = 570; //altezza di default
		this.doms = new ArrayList<Domanda>();
		this.textD = new ArrayList<String>();
		this.count = 0;
		this.index = 0;
		this.fileName = new String("");

		// controllo la grandezza dello schermo
		Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
		if(screenSize.getHeight() <= 600) 
			h = (int) (screenSize.getHeight() - 30);

		this.jfrm = new JFrame(this.appName);
		this.jfrm.setSize(640, h);
		this.jfrm.setResizable(false);
		this.jfrm.setLocationRelativeTo(null); //centro JFrame
		this.jfrm.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		this.jfrm.addWindowListener(new WindowListener() {
			
			@Override
			public void windowOpened(WindowEvent e) {
				// TODO Auto-generated method stub
				
			}
			
			@Override
			public void windowIconified(WindowEvent e) {
				// TODO Auto-generated method stub
				
			}
			
			@Override
			public void windowDeiconified(WindowEvent e) {
				// TODO Auto-generated method stub
				
			}
			
			@Override
			public void windowDeactivated(WindowEvent e) {
				// TODO Auto-generated method stub
				
			}
			
			@Override
			public void windowClosing(WindowEvent e) {

				if (doms.isEmpty()) { //nessuna domanda inserita
					return ;
				}
				
				if (JOptionPane.showConfirmDialog(null, "Vuoi salvare prima di chiudere?", appName, JOptionPane.YES_NO_OPTION) != 0)
					return;
				
				if(fileName.compareTo("") == 0){
					saveDBSelezionaFile(true);
				} else {
					saveDB(true);
				}
				
			}
			
			@Override
			public void windowClosed(WindowEvent e) {
				// TODO Auto-generated method stub
				
			}
			
			@Override
			public void windowActivated(WindowEvent e) {
				// TODO Auto-generated method stub
				
			}
		});
		this.jfrm.setLayout(new BorderLayout());
		this.jfrm.setIconImage(new ImageIcon(getClass().getResource("logo.png")).getImage());

		/* 
		 * Disegno i menu
		 */

		this.drawMenu();


		/*
		 * Parte alta del JFrame
		 */
		JPanel p = new JPanel(new FlowLayout());
		p.setBorder(BorderFactory.createCompoundBorder(
				BorderFactory.createTitledBorder("Titolo del Sondaggio"),
				BorderFactory.createEmptyBorder(10, 10, 10, 10)));
		JPanel pTitle = new JPanel(new GridLayout(1, 2));
		JLabel lab1 = new JLabel("Inserisci il titolo: ");
		pTitle.add(lab1);
		this.textTitle = new JTextField(25);
		this.textTitle.setDocument(new JTextFieldLimit(50));
		this.textTitle.setToolTipText("Lunghezza massima 50 caratteri");
		pTitle.add(this.textTitle);
		p.add(pTitle);
		this.jfrm.add(p, BorderLayout.NORTH);

		/*
		 * Parte centrale frame 
		 */
		JPanel pan = new JPanel();
		pan.setLayout(new BoxLayout(pan, BoxLayout.LINE_AXIS));

		// Inserisco le domande
		this.disegnaFormDomande();
		JScrollPane jscroll = new JScrollPane(this.domandePan);
		jscroll.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED);
		pan.add(jscroll);
		//Inserisco la lista delle domande inserite
		this.disegnaListaDomande();
		pan.add(this.rightPanel);

		this.jfrm.add(pan, BorderLayout.CENTER);

		/*
		 * Mostro la JFrame completa
		 */
		this.jfrm.setVisible(true);
	}

	private void drawMenu()
	{
		JMenuItem nuovo = new JMenuItem("Nuovo");
		nuovo.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				
				if(doms.size() != 0)
					if (JOptionPane.showConfirmDialog(jfrm, "Sei sicuro di cancellare le domande presenti nel DB?", appName, JOptionPane.YES_NO_OPTION) != 0)
						return;
				
				Grafix.this.azzeraDB();
				//dico che non c' alcun file aperto
				fileName = new String("");
				salvaCome.setEnabled(false);
			}
		});
		nuovo.setIcon(new ImageIcon(getClass().getResource("new.png")));

		JMenuItem apri = new JMenuItem("Apri");
		apri.addActionListener(new ActionListener()
		{
			public void actionPerformed(ActionEvent e) {
				if(!doms.isEmpty()) {
					if (JOptionPane.showConfirmDialog(null, "Vuoi salvare prima creare un nuovo sondaggio?", appName, JOptionPane.YES_NO_OPTION) != 0)
						return;
				}
				if (openDB() == false)
					JOptionPane.showMessageDialog(jfrm, "Impossibile aprire il DataBase.", appName, JOptionPane.WARNING_MESSAGE);
				salvaCome.setEnabled(true);
			}
		});
		apri.setIcon(new ImageIcon(getClass().getResource("open.png")));

		JMenuItem salva = new JMenuItem("Salva");
		salva.addActionListener(new ActionListener()
		{
			public void actionPerformed(ActionEvent e) {
				if (doms.isEmpty()) {
					JOptionPane.showMessageDialog(jfrm, "DB vuoto, nulla da salvare.", appName, JOptionPane.INFORMATION_MESSAGE);
					return;
				}
				
				if(fileName.compareTo("") == 0){
					if (saveDBSelezionaFile(false)) {
						salvaCome.setEnabled(true);
						JOptionPane.showMessageDialog(jfrm, "E' possibile continuare l'inserimento.", appName, JOptionPane.INFORMATION_MESSAGE);
					}
				} else {
					if (saveDB(false)) {
						salvaCome.setEnabled(true);
						JOptionPane.showMessageDialog(jfrm, "E' possibile continuare l'inserimento.", appName, JOptionPane.INFORMATION_MESSAGE);
					}
				}

			}
		});
		salva.setIcon(new ImageIcon(getClass().getResource("salva.png")));

		salvaCome = new JMenuItem("Salva come");
		salvaCome.addActionListener(new ActionListener()
		{
			public void actionPerformed(ActionEvent e) {  
				if (doms.isEmpty()) { 
					JOptionPane.showMessageDialog(jfrm, "DB vuoto, nulla da salvare.");
					return;
				}
				
				if (saveDBSelezionaFile(false)) {
					JOptionPane.showMessageDialog(jfrm, "E' possibile continuare l'inserimento.", appName, JOptionPane.INFORMATION_MESSAGE);
				}

			}
		});
		salvaCome.setEnabled(false);
		salvaCome.setIcon(new ImageIcon(getClass().getResource("salva.png")));


		JMenuItem anDb = new JMenuItem("Analizza DataBase");
		anDb.addActionListener(new ActionListener()
		{
			public void actionPerformed(ActionEvent e) {
				new Analyzer();
			}
		});
		anDb.setIcon(new ImageIcon(getClass().getResource("analize.png")));

		JMenuItem helpItem = new JMenuItem("About");
		helpItem.addActionListener(new ActionListener() {

			public void actionPerformed(ActionEvent e) {
				 try {
	                    if(Desktop.isDesktopSupported()) {
	                        Desktop.getDesktop().browse(new URI("https://sites.google.com/site/lucianogiuseppeprogrammi/"));
	                    } else {
	                        JOptionPane.showMessageDialog(null, "Vai a: https://sites.google.com/site/lucianogiuseppeprogrammi/");
	                    }
	                } catch (URISyntaxException ex) {
	                	JOptionPane.showMessageDialog(jfrm, ex.toString(), appName, JOptionPane.ERROR_MESSAGE);
	                } catch (IOException ex) {
	                	JOptionPane.showMessageDialog(jfrm, ex.toString(), appName, JOptionPane.ERROR_MESSAGE);
	                }

			}
		});
		helpItem.setIcon(new ImageIcon(getClass().getResource("help.png")));

		JMenu mFile = new JMenu("File");
		mFile.add(nuovo);
		mFile.addSeparator();
		mFile.add(apri);
		mFile.addSeparator();
		mFile.add(salva);
		mFile.add(salvaCome);
		JMenu mAltro = new JMenu("Utility");
		mAltro.add(anDb);
		JMenu mHelp = new JMenu("Help");
		mHelp.add(helpItem);

		JMenuBar mBar = new JMenuBar();
		mBar.add(mFile);
		mBar.add(mAltro);
		mBar.add(mHelp);

		this.jfrm.setJMenuBar(mBar);
	}

	private void disegnaListaDomande()
	{
		rightPanel = new JPanel(new BorderLayout());
		rightPanel.setBorder(BorderFactory.createCompoundBorder(
				BorderFactory.createTitledBorder("Domande inserite"),
				BorderFactory.createEmptyBorder()));

		jlist = new JList<Object>();
		jlist.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
		jlist.addListSelectionListener(new ListSelectionListener() {

			public void valueChanged(ListSelectionEvent e) {
				int indx = jlist.getSelectedIndex();
				if(indx != -1) {
					Grafix.this.index = indx;
					Grafix.this.visualizzaDomande(indx);
				}
			}
		});
		
		JScrollPane jscroll = new JScrollPane(jlist);
		jscroll.setPreferredSize(new Dimension(120,350));
		jscroll.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
		rightPanel.add(jscroll,BorderLayout.CENTER);
		
		JButton rimuovi = new JButton("Rimuovi");
		rimuovi.addActionListener(new ActionListener() {
			
			@Override
			public void actionPerformed(ActionEvent arg0) {
				int indx = jlist.getSelectedIndex();
				if(indx != -1) {
					doms.remove(indx);
					annulla();
					riempiList();
				}
				
			}
		});
		rightPanel.add(rimuovi, BorderLayout.PAGE_END);
		

		return;
	}

	private void disegnaFormDomande()
	{
		this.domandePan = new JPanel(new GridLayout(6, 1));
		this.domandePan.setBorder(BorderFactory.createCompoundBorder(
				BorderFactory.createTitledBorder("Contenuto della Domanda"),
				BorderFactory.createEmptyBorder(10, 10, 10, 10)));
		this.domandePan.setPreferredSize(new Dimension(400,430));
		this.domandePan.setMaximumSize(new Dimension(400,430));

		//inserisco il pannello col titolo della domanda
		JPanel pan1 = new JPanel(new FlowLayout());
		JLabel domText = new JLabel("Inserisci testo domanda");
		pan1.add(domText);
		this.testoDom = new JTextField(30);
		this.testoDom.setDocument(new JTextFieldLimit(70));
		this.testoDom.setToolTipText("Lunghezza massima 70 caratteri");
		pan1.add(this.testoDom);
		this.domandePan.add(pan1);


		//inserisco il pannello col testo risposta 1
		JPanel pan2 = new JPanel(new FlowLayout());
		JLabel rispText1 = new JLabel("Inserisci testo della risposta n1");
		pan2.add(rispText1);
		this.testoRisp1 = new JTextField(25);
		this.testoRisp1.setDocument(new JTextFieldLimit(40));
		this.testoRisp1.setToolTipText("Lunghezza massima 40 caratteri");
		pan2.add(this.testoRisp1);
		this.domandePan.add(pan2);

		//inserisco il pannello col testo risposta 2
		JPanel pan3 = new JPanel(new FlowLayout());
		JLabel rispText2 = new JLabel("Inserisci testo della risposta n2");
		pan3.add(rispText2);
		this.testoRisp2 = new JTextField(25);
		this.testoRisp2.setDocument(new JTextFieldLimit(40));
		this.testoRisp2.setToolTipText("Lunghezza massima 40 caratteri");
		pan3.add(this.testoRisp2);
		this.domandePan.add(pan3);

		//inserisco il pannello col testo risposta 3
		JPanel pan4 = new JPanel(new FlowLayout());
		JLabel rispText3 = new JLabel("Inserisci testo della risposta n3");
		pan4.add(rispText3);
		this.testoRisp3 = new JTextField(25);
		this.testoRisp3.setDocument(new JTextFieldLimit(40));
		this.testoRisp3.setToolTipText("Lunghezza massima 540 caratteri");
		pan4.add(this.testoRisp3);
		this.domandePan.add(pan4);

		//inserisco il pannello col testo risposta 4
		JPanel pan5 = new JPanel(new FlowLayout());
		JLabel rispText4 = new JLabel("Inserisci testo della risposta n4");
		pan5.add(rispText4);
		this.testoRisp4 = new JTextField(25);
		this.testoRisp4.setDocument(new JTextFieldLimit(40));
		this.testoRisp4.setToolTipText("Lunghezza massima 40 caratteri");
		pan5.add(this.testoRisp4);
		this.domandePan.add(pan5);

		//inserisco il pannello dei pulsanti
		JPanel pan6 = new JPanel(new GridLayout(1, 2));
		JButton jNuovo = new JButton("Nuova Domanda");
		jNuovo.addActionListener(new ActionListener()
		{
			public void actionPerformed(ActionEvent e) {
				Grafix.this.nuovaDomanda();
			}
		});
		JButton jIns = new JButton("Inserisci");
		jIns.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				if (insDomanda() != false)
					JOptionPane.showMessageDialog(jfrm, "Domanda inserita correttamente.", appName, JOptionPane.INFORMATION_MESSAGE);
				else
					JOptionPane.showMessageDialog(jfrm, "Completare almeno i campi: domanda, risposta 1 e risposta 2.\nControllare anche i campi minuti e secondi", appName, JOptionPane.WARNING_MESSAGE);
			}
		});
		JButton jAnn = new JButton("Annulla");
		jAnn.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				Grafix.this.annulla();
			}
		});

		JPanel panel2 = new JPanel(new FlowLayout());
		panel2.add(jNuovo);
		pan6.add(panel2);

		JPanel panel1 = new JPanel(new FlowLayout());
		panel1.add(jIns);
		panel1.add(jAnn);
		pan6.add(panel1);
		this.domandePan.add(pan6);

		return;
	}

	protected JSpinner addLabeledSpinner(Container c,
			String label, 
			JSpinner spinner,
			SpinnerModel model) {
		JLabel l = new JLabel(label);
		c.add(l);

		spinner = new JSpinner(model);
		l.setLabelFor(spinner);
		c.add(spinner);

		return spinner;
	}


/*
 *  Parte Logica della GUI
 */
	private void azzeraDB()
	{
		annulla();
		this.count = 0;
		this.index = 0;

		this.doms.clear();
		this.textD.clear();
		this.jlist.setListData(textD.toArray());
		this.textTitle.setText("");

		Runtime.getRuntime().gc();
	}

	private boolean openDB()
	{

		JFileChooser file = new JFileChooser();
		FileNameExtensionFilter filtro = new FileNameExtensionFilter("Poll xml file: *.xml", new String[] { "xml" });
		file.setFileFilter(filtro);
		if (file.showOpenDialog(this.jfrm) != 0) {
			JOptionPane.showMessageDialog(jfrm, "Impossibile caricare il file", this.appName, JOptionPane.ERROR_MESSAGE);
			return false;
		}

		this.fileName = new String(file.getSelectedFile().getPath());

		PollDb poll = OpenSave.apri(this.fileName);
		if(poll == null) {
			this.fileName = "";
			return false;
		}
		
		this.textTitle.setText(poll.getTitle());
		this.doms = poll.getDomande();
		this.count = this.doms.size();
		this.index = 0;

		/*
		 * Lista domande nella  List Box
		 */
		this.riempiList();

		this.jlist.setSelectedIndex(index);
		visualizzaDomande(this.index);

		Runtime.getRuntime().gc();

		return true;
	}

	private boolean saveDBSelezionaFile(boolean chiusura)
	{
		
		String titolo = new String(this.textTitle.getText().trim());
		if(titolo.compareTo("") == 0) {
			if(chiusura) {
				titolo = JOptionPane.showInputDialog(jfrm, "Inserire il titolo del sondaggio", appName, JOptionPane.QUESTION_MESSAGE);
				if(titolo == null)
					return false;
				titolo = titolo.trim();
				if(titolo.compareTo("") == 0)
					return false;
			} else {
				JOptionPane.showMessageDialog(jfrm, "Inserire il titolo del Poll.", this.appName, JOptionPane.WARNING_MESSAGE);
				return false;
			}
		}


		Runtime.getRuntime().gc();
		
		//seleziono il file dove salvare
		JFileChooser file = new JFileChooser();
		FileNameExtensionFilter filtro = new FileNameExtensionFilter("Poll xml file: *.xml", new String[] { "xml" });
		file.setFileFilter(filtro);
		if (file.showSaveDialog(this.jfrm) != 0) {
			JOptionPane.showMessageDialog(jfrm, "Impossibile salvare il file", this.appName, JOptionPane.ERROR_MESSAGE);
			return false;
		}

		this.fileName = file.getSelectedFile().getPath();
		//salvo il database
		PollDb poll = new PollDb(doms, titolo);
		if(OpenSave.salva(poll, this.fileName)) {
			JOptionPane.showMessageDialog(jfrm, "File salvato in: " + this.fileName, this.appName, JOptionPane.INFORMATION_MESSAGE);
		} else {
			JOptionPane.showMessageDialog(jfrm, "File non salvato", this.appName, JOptionPane.WARNING_MESSAGE);
			this.fileName = "";
			return false;
		}
		Runtime.getRuntime().gc();

		
		return true;
	}

	private boolean saveDB(boolean chiusura)
	{

		String titolo = new String(this.textTitle.getText().trim());
		if(titolo.compareTo("") == 0) {
			if(chiusura) {
				titolo = JOptionPane.showInputDialog(jfrm, "Inserire il titolo del sondaggio", appName, JOptionPane.QUESTION_MESSAGE);
				if(titolo == null)
					return false;
				titolo = titolo.trim();
				if(titolo.compareTo("") == 0)
					return false;
			} else {
				JOptionPane.showMessageDialog(jfrm, "Inserire il titolo del Poll.", this.appName, JOptionPane.WARNING_MESSAGE);
				return false;
			}
		}

		
		Runtime.getRuntime().gc();

		//salvo il database
		PollDb poll = new PollDb(this.doms, titolo);
		if(OpenSave.salva(poll, this.fileName)) {
			JOptionPane.showMessageDialog(jfrm, "File salvato in: " + this.fileName, this.appName, JOptionPane.INFORMATION_MESSAGE);
		} else {
			JOptionPane.showMessageDialog(jfrm, "File non salvato", this.appName, JOptionPane.WARNING_MESSAGE);
			return false;
		}
		Runtime.getRuntime().gc();

		return true;
	}
	
	private void annulla()
	{
		this.testoDom.setText("");
		this.testoRisp1.setText("");
		this.testoRisp2.setText("");
		this.testoRisp3.setText("");
		this.testoRisp4.setText("");
	}

	private void nuovaDomanda()
	{
		this.index = this.count;
		annulla();
	}

	private void visualizzaDomande(int index)
	{
		Domanda d = this.doms.get(index);
		this.testoDom.setText(d.getDomanda());
		this.testoRisp1.setText(d.getRisp1());
		this.testoRisp2.setText(d.getRisp2());

		if (d.isAttRisp3())
			this.testoRisp3.setText(d.getRisp3());
		else
			this.testoRisp3.setText("");

		if (d.isAttRisp4())
			this.testoRisp4.setText(d.getRisp4());
		else
			this.testoRisp4.setText("");
	}

	private boolean insDomanda()
	{
		String dom = this.testoDom.getText().trim();
		String r1 = this.testoRisp1.getText().trim();
		String r2 = this.testoRisp2.getText().trim();

		if ((dom.compareTo("") == 0) || (r1.compareTo("") == 0) || (r2.compareTo("") == 0))
		{
			return false;
		}
		
		
		Domanda d = new Domanda();
		d.setDomanda(dom);
		d.setRisp1(r1);
		d.setRisp2(r2);

		String s = this.testoRisp3.getText().trim();
		if (s.compareTo("") != 0) {
			d.setRisp3(s);
			s = this.testoRisp4.getText().trim();
			if (s.compareTo("") != 0) {
				d.setRisp4(s);
			}
		}

		if (this.index < this.count) {
			this.doms.set(this.index, d);
			this.riempiList();
		} else {
			this.index += 1;
			this.count += 1;
			
			//mostra la domanda nella list
			if(dom.length() < 30) {
				this.textD.add(dom);
			} else {
				this.textD.add(dom.substring(0, 29)+"...");
			}
			this.jlist.setListData(textD.toArray());
			this.doms.add(d);
			annulla();
		}

		return true;
	}

	private void riempiList()
	{
		String s;

		this.textD.clear();
		for(Domanda d: this.doms) {
			if(d == null)
				continue; //giusto per sicurezza
			s = d.getDomanda();
			if(s.length() < 30) {
				this.textD.add(s);
			} else {
				this.textD.add(s.substring(0, 29)+"...");
			}
		}
		this.jlist.setListData(textD.toArray());
	}		
	
}
